;;;Bosse-engineering                                                                                       
;;;Dipl.-Ing. Jrn Bosse                                                                                   
;;;Major-Hirst-Str. 11                                                                                     
;;;38442 Wolfsburg                                                                                         
;;;Tel. 0 53 61 / 8 97 77 77                                                                               
;;;mobil. 01 76 / 28 23 23 51                                                                              
;;;bosse@bosse-engineering.com                                                                             
;;;                                                                                                        
;;;--------------------------------------------------------------------------------------------------------
;;;JBO-Tools                                                                                               
;;;Funktionen fr die Standalone-Programme von Jrn Bosse                                                  
;;; !!!!Diese Datei mu auf einem Supportpfad von AutoCAD liegen.!!!!                                      
;;;                                                                                                        
;;;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;;;                                                                              Jrn Bosse, 15.03.07      
;;;--------------------------------------------------------------------------------------------------------

;;;BENUTZERANPASSUNG Userpfad:                                                                             
;;;Der Userpfad muss auf allen Rechnern vorhanden sein, innerhalb dieses Pfades werden *.ini und *.lsp     
;;;Dateien gespeichert, die zur Sicherung von Vorgabeeinstellungen verwendet werden.                       
;;;Der Userpfad kann benutzerspezifisch angepasst werden.                                                  
;;;Vorsicht: wenn nach den Laufwerksbuchstaben nur ein Unterverzeichnis vorhanden ist, dann wird der Pfad  
;;;automatisch erstellt (z.B. "c:\\ACAD\\"), wenn der Pfad mehrere Verzeichnisse enthlt mssen Sie diesen 
;;;manuell erstellen (z.B. c:\\ACAD\\noch_ein_Verzeichnis\\")                                              
(defun JBf_JBO_pfad ( / userpfad)
  (setq userpfad
	 "c:\\ACAD\\" ;;;Hier ndern
	)
  (if (not (JBf_string_dateipfad->true-false userpfad))
  (vl-mkdir userpfad))
  userpfad
  )

;;;******************************************************************************************;;;
;;;Gltigkeit eines Dateipfades prfen                                                       ;;;
;;;******************************************************************************************;;;
(vl-load-com)
(defun JBf_string_dateipfad->true-false	(pfad1 / FSO TRUE-FALSE)
  (if (vl-string-search "." pfad1)
    (setq pfad1 (JBf_string_dateipfad->only pfad1)))
  (if (setq FSO (vlax-create-object "Scripting.FilesystemObject"))
    (progn
      (if (vlax-method-applicable-p FSO 'FOLDEREXISTS)
	(setq TRUE-FALSE
	   (=(vl-catch-all-apply
		   'vlax-invoke-method
		   (list FSO 'FOLDEREXISTS pfad1)):vlax-true))
      (vlax-release-object FSO))))
  TRUE-FALSE)
;********************************************************************************************;;;
;;;JBf_JBO_vari_sicher  Sichern der Systemvariablen und optional fr Programmablauf Zuweisung  ;
;;;                     neuer Werte                                                          ;;;
;;;******************************************************************************************;;;
(defun JBf_JBO_vari_sicher (/)
  '(
    ("plinetype" nil)
    ("osmode" 0)
    ("cmdecho" 0)
    ("clayer" nil)
    ("dimzin" 3)
    ("pickadd"nil) 
    ("AUNITS" 3)
    ("ANGDIR" 0)
    ("ANGBASE" 0.0)
    ("ATTREQ"nil)
    ("CECOLOR" "BYLAYER")
    ("EXTNAMES"nil)
    ("ATTDIA" 0)
    ("CELTYPE" "BYLAYER")
    ("CELWEIGHT" -1)
    ("INSUNITS" 0)
    ("INSUNITSDEFSOURCE" 0)
    ("INSUNITSDEFTARGET" 0)
    ("EXPERT" 0)
    ("LUNITS" nil)
    ("LUPREC" nil)
    ("AUPREC" nil)
    ("filedia" nil)
    
    ))
 
;;;Initialisierung
(defun JBf_JBO_init ( /)
  (setvar "ERRNO" 0)
  (setq	Err *error*
	*error* JBf_JBO_Fehler)
  (setq JBosse_JBO_$$vari nil)
;;;Systemvariablen sichern
  (setq JBosse_JBO_$$vari (mapcar '(lambda(A) (getvar (car A)))(JBf_JBO_vari_sicher)))
  (vl-load-com)
;;;neue Werte fr Systemvariablen
  (mapcar '(lambda(A)
	     (if (cadr A)
	       (setvar (car A)(cadr A))))(JBf_JBO_vari_sicher)))	
;;;Fehlermeldung
(defun JBf_JBO_Fehler  (s)
  (print (strcat "***Fehler*** " s))
  (JBf_JBO_Reinit))
;;;Zurcksetzen
(defun JBf_JBO_Reinit ( / n)
  (setq n 0)
  (mapcar '(lambda(A)
	     (setvar (car A) (nth n JBosse_JBO_$$vari))
	     (setq n (+ n 1)))(JBf_JBO_vari_sicher))
  (setq *error* Err
	Err nil)
  (princ)
)

;;;Zurck, Beginn
(defun JBf_JBO_zuruck_b(/ cmdecho_alt)
  (setq cmdecho_alt (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (command "_.undo" "_be")
  (setvar "CMDECHO" cmdecho_alt))
;;;Zurck, Ende
(defun JBf_JBO_zurueck_e(/ cmdecho_alt)
  (setq cmdecho_alt (getvar "CMDECHO"))
  (setvar "CMDECHO" 0)
  (command "_.undo" "_e")
  (setvar "CMDECHO" cmdecho_alt))


